%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% CODE OF OMCMC-NKC "PARALLEL METROPOLIS-HASTINGS COUPLER"
%%%% Related papers:
%%%%
%%%% F. Llorente, L. Martino, D. Delgado, "Parallel Metropolis-Hastings Coupler",
%%%% (to appear) IEEE Signal Processing Letters, 2019.
%%%%
%%%% L. Martino, V. Elvira, D. Luengo, J. Corander, F. Louzada, 
%%%% "Orthogonal Parallel MCMC Methods for Sampling and Optimization", 
%%%% Digital Signal Processing Volume 58, Pages: 64-84, 2016.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all
close all
clc
help('MAIN_for_run')
%%%%%%%%%
N=10;  %%% chains- population
Tv=5; %% vertical steps
Th=5; %% horizontal steps
M=2000;%% epoch
typeIni=1; %%% type initialization
sigpropV=5;%%% std vertical
sigpropH=5;%%% std horizontal 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
x_tot=OMCMC_NKC_public(N,Tv,Th,M,sigpropV,sigpropH,typeIni);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
plot(x_tot(1,:),x_tot(2,:),'r.')
figure
[aux1,aux2]=hist3([x_tot(1,:)' x_tot(2,:)'],[30 30]);
pcolor(aux1')
shading interp
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%