function [x_tot]=OMCMC_NKC_public(N,Tv,Th,M,sigpropV,sigpropH,typeIni)
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% Interacting Parallel Metropolis Sampler %%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% %%%%%%%
% %% with multimodal bivariate target %%%%%%%
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % N= number of chain
% % M= number of Epochs
% % sigpropV = std of the proposal pdfs of the vertical chains
% % sigproph = initial std of the proposal pdf in SMH
% % x_tot= returned samples (states of the chains)


 

if M<1
    M=1;
end 

if Tv<0
    Tv=0;
end 
    



  
   
     
  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% TARGET %%%%%%%%%%%%%%%%%%%%%
type=1; %%%% type of the  target distribution %%% change target.m
logf=@(x) target(x,type);
DIM=2; %%% problem dimension 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% parameters %%%%%%%%%%%%%%%%%%%%%
    


if typeIni==1
     initialPoints=-4+8*rand(N,DIM);
elseif  typeIni==2
     initialPoints=[-20 -20]+repmat([40 40],N,1).*rand(N,DIM);
end 

x{1}=initialPoints;
SIGMA=sigpropV.^2*eye(DIM);
x_tot=[];
%mupropH=0*ones(DIM,1);
%sigpropHvect=sigpropH*ones(DIM,1);
%%%%%%%% Training=fix(M/(0.7*Tv*N)); %%% possible suggestion
 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% aux code par. %%%%%%%%%%%%%%%%%%%%%
%%%% showPlots=1; %%% 0: nothing 1: show  
   counter=1;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%% START %%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

for i=2:M+1;
    
   if mod(i,100)==0
       disp([num2str(min([fix(i*100/M) 100])) '%'])
   end

 
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 %%%%%%%%%%%%% Propagation of the VERTICAL CHAINS %%%%%%%%%%%%%
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
  for j=1:Tv 
      
     counter=counter+1;
     x{counter}=mvnrnd(x{counter-1},SIGMA);
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   
    Vbef=logf(x{counter-1});
    Vnow=logf(x{counter});
    [d1,d2]=size(Vbef);
     if d1>d2
         Vbef=Vbef';
         Vnow=Vnow';
     end
    rho=exp(Vnow-Vbef);
    alpha=min([ones(1,N);rho]);
    %%% Test %%%
    u=rand(1,N);
    test=(u<=alpha);
    vec_aux=(x{counter}-x{counter-1}).*repmat(test',1,DIM);
    x{counter}=x{counter-1}+vec_aux;
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
      x_tot=[x_tot x{counter}'];
 
  end
  
  
 
       
       
       
       if Th~=0
           [x_now]=NKC(Th,N,sigpropH,1,2,x{counter}');
       %%%%x_now=SMH(mupropH,sigpropHvect,N,Th,x{counter}',logf);
         counter=counter+1;
          x{counter}=x_now';
        x_tot=[x_tot x{counter}'];
       end
  
  
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%% END of one EPOCH %%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
       
       
end





